--==========================================================================
-- PROGRAM: cgi.e
--  AUTHOR: bjackson
--    DATE: 2 July 1999
-- PURPOSE: To parse CGI POST/GET responces and CGI Environment Variables
--==========================================================================
include get.e

global constant STDIN = 0
global atom CONTENT_LENGTH
global sequence CGIKEY, 
		CGIVALUE,
		AUTH_TYPE,
		CONTENT_TYPE,
		GATEWAY_INTERFACE,
		PATH_INFO,
		PATH_TRANSLATED,
		QUERY_STRING,
		REMOTE_ADDR,
		REMOTE_HOST,
		REMOTE_IDENT,
		REMOTE_USER,
		SCRIPT_NAME,
		SERVER_NAME,
		SERVER_PORT,
		SERVER_PROTOCOL,
		SERVER_SOFTWARE
--==========================================================================
function hexrep(sequence hexdata)
    
    -- evaluates a hex string to a decimal value
    atom awork
    atom asciival
    
    awork = hexdata[1]
    awork = awork - 48
    if awork > 9 then
	awork = awork - 7
    end if
    asciival = awork * 16

    awork = hexdata[2]
    awork = awork - 48
    if awork > 9 then
	awork = awork - 7
    end if
    asciival = asciival + awork
    return(asciival)
end function
--==========================================================================
global procedure cgiparse()
    object owork,owork2
    integer count
    atom awork
    
    -- get the CGI environment variables
    owork = getenv("AUTH_TYPE")
    if not atom(owork) then
    	AUTH_TYPE = owork
    else
    	AUTH_TYPE = ""
    end if
    
    owork = getenv("CONTENT_TYPE")
    if not atom(owork) then
    	CONTENT_TYPE = owork
    else
    	CONTENT_TYPE = ""
    end if
    
    owork = getenv("GATEWAY_INTERFACE")
    if not atom(owork) then
    	GATEWAY_INTERFACE = owork
    else
    	GATEWAY_INTERFACE = ""
    end if
    
    owork = getenv("PATH_INFO")
    if not atom(owork) then
    	PATH_INFO = owork
    else
    	PATH_INFO = ""
    end if
    
    owork = getenv("PATH_TRANSLATED")
    if not atom(owork) then
    	PATH_TRANSLATED = owork
    else
    	PATH_TRANSLATED = ""
    end if
    
    owork = getenv("QUERY_STRING")
    if not atom(owork) then
    	QUERY_STRING = owork
    else
    	QUERY_STRING = ""
    end if
    
    owork = getenv("REMOTE_ADDR")
    if not atom(owork) then
    	REMOTE_ADDR = owork
    else
    	REMOTE_ADDR = ""
    end if
    
    owork = getenv("REMOTE_HOST")
    if not atom(owork) then
    	REMOTE_HOST = owork
    else
    	REMOTE_HOST = ""
    end if
    
    owork = getenv("REMOTE_IDENT")
    if not atom(owork) then
    	REMOTE_IDENT = owork
    else
    	REMOTE_IDENT = ""
    end if
    
    owork = getenv("REMOTE_USER")
    if not atom(owork) then
    	REMOTE_USER = owork
    else
    	REMOTE_USER = ""
    end if
    
    owork = getenv("SCRIPT_NAME")
    if not atom(owork) then
    	SCRIPT_NAME = owork
    else
    	SCRIPT_NAME = ""
    end if
    
    owork = getenv("SERVER_NAME")
    if not atom(owork) then
    	SERVER_NAME = owork
    else
    	SERVER_NAME = ""
    end if
    
    owork = getenv("SERVER_PORT")
    if not atom(owork) then
    	SERVER_PORT = owork
    else
    	SERVER_PORT = ""
    end if
    
    owork = getenv("SERVER_PROTOCOL")
    if not atom(owork) then
    	SERVER_PROTOCOL = owork
    else
    	SERVER_PROTOCOL = ""
    end if
    
    owork = getenv("SERVER_SOFTWARE")
    if not atom(owork) then
    	SERVER_SOFTWARE = owork
    else
    	SERVER_SOFTWARE = ""
    end if
    
    owork = getenv("CONTENT_LENGTH")
    if atom(owork) then
	CONTENT_LENGTH = 0
    else
	owork2 = value(owork)
	if owork2[1] = GET_SUCCESS then
	    CONTENT_LENGTH = owork2[2]
	else
	    CONTENT_LENGTH = 0
	end if
    end if


    -- 'Normalize' the cgi POST/GET data,and separate entries into KEYS/VALUES

    count = 1 
    owork = ""
    
    -- read the POST (or GET) data from STDIN
    if CONTENT_LENGTH then
        owork2 = gets(STDIN)
    else
        owork2 = QUERY_STRING
    end if
	
    CGIKEY = {}
    CGIVALUE = {}

    while count <= length(owork2) do
        awork = owork2[count]
    
        if not compare(awork,'=') then
            -- the key is done, so store it
	    CGIKEY = append(CGIKEY,owork)
	    owork = ""
	elsif not compare(awork,'&') then
	    -- the value is done, so store it
	    CGIVALUE = append(CGIVALUE,owork)
	    owork = ""
	elsif not compare(awork,'%') then
	    -- then next two characters are HEX, so replace them with ASCII
	    owork = owork & hexrep(owork2[count+1..count+2])
	    count += 2
	elsif not compare(awork,'+') then
	    -- this is the escape character for a space
	    owork = owork & ' '
	else 
	    -- none of the above, so get the next character
	    owork = owork & awork
	end if
    
	count += 1
    end while
    CGIVALUE = append(CGIVALUE,owork)
end procedure
--============================================================================
